﻿/**
    URL adresy se definují na stránce která to používá

    Myšleno jako sdílené podmínky nad požadavkem na více místech.
**/

var logged_user_select2_data_option_without_customer = { id: "EMPTY_VALUE", text: '-- bez společnosti --' };

$(document).ready(function () {
    initConditionTree();
});

function initConditionTree() {
    refreshRelationships();
    $(".datepicker").datepicker();
    $(".conditions").find(".column-type").select2({ dropdownAutoWidth: true }); //reinit sirky (kvuli options)
    $(".conditions").find(".column-operators").select2({ dropdownAutoWidth: true, minimumResultsForSearch: Infinity });
    $(".conditions").find(".select2-for-views").select2({ multiple: true, placeholder: Localization_SelectInSelect }).addClass("left");
    $(".conditions").find(".select2-for-users").select2({
        minimumInputLength: 0,
        multiple: true,
        placeholder: Localization_Search,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    showEmail: true,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
    }).addClass("left");
    $(".conditions").find(".select2-for-customers").select2({
        minimumInputLength: 0,
        placeholder: Localization_Search,
        allowClear: true,
        ajax: {
            url: RQ_URL + '/Customers/CustomersForSelect2Ajax',
            type: 'POST',
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;
                data.Results.unshift(logged_user_select2_data_option_without_customer);

                return {
                    results: data.Results,
                    pagination:
                    {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: false,
        }
    }).addClass("left");
    $($(".conditions").find(".select2-for-views")).each(function (index, value) {
        $(value).val(($(value).closest("div").find(".conditionDefaultValue").val() + "").split(",")).trigger("change");
    });
    $($(".conditions").find(".select2-for-users")).each(function (index, value) {
        $(value).val(($(value).closest("div").find(".conditionDefaultValue").val() + "").split(",")).trigger("change");
    });
    $($(".conditions").find(".select2-for-customers")).each(function (index, value) {
        $(value).val(($(value).closest("div").find(".conditionDefaultValue").val() + "").split(",")).trigger("change");
    });

    $(".condition-for-automation-event").draggable({
        handle: ".handle",
        helper: "original",
        appendTo: "body",
        revert: "invalid",
        cursor: "move",
        zIndex: 10000,
        scroll: true,
        start: function (event, ui) {
            elementDepth = 0;
        },
        stop: function (event, ui) {
            if (!revert) {

            }
        }

    });

    $(".condition-for-automation-event").droppable({
        tolerance: "pointer",
        out: function (event, ui) {
            revert = true;
        },
        over: function (event, ui) {
            revert = false;
        },
        drop: function (event, ui) {
            revert = false;
            actualElementDepth = $(event.target).parents("*").not("body,html").size();
            var dataid = $(event.target).attr("data-id");
            if (actualElementDepth > elementDepth) {
                var top = ui.offset.top - $(this).offset().top;
                var height = 5;
                if (top >= height) {
                    $(event.target).find(".sub-children:first").append($(ui.draggable));
                }
                else {
                    $(event.target).before($(ui.draggable));
                }
                $(".condition-for-automation-event").css("left", "0px");
                $(".condition-for-automation-event").css("top", "0px");
            }
            refreshRelationships();
            elementDepth = actualElementDepth;
        }
    });

    initSpinners();
}

function addNewFiltr() {
    $(newConditionButton).hide();
    $(".conditions").append($("#TicketCondition").html());

    $.ajax({
        url: RQ_URL + getRuleFieldValuesForSelect2,
        context: document.body,
        async: false
    }).done(function (data) {
        var options = createOptionsForColumnType(data);
        $(".conditions").find(".column-type").last().append(options);
        $(".conditions").find(".column-type").last().select2({ dropdownAutoWidth: true }); //reinit sirky (kvuli options)
        $(".conditions").find(".column-operators").last().hide();
        $(".conditions").find(".column-type").last().val("-1").trigger("change");
    })
    .error(function (error) {
        alert(error.responseText);
    });
    refreshRelationships();

    $(".condition-for-automation-event").draggable({
        handle: ".handle",
        helper: "original",
        appendTo: "body",
        revert: "invalid",
        cursor: "move",
        zIndex: 10000,
        scroll: true,
        start: function (event, ui) {
            elementDepth = 0;
        },
        stop: function (event, ui) {
            if (!revert) {

            }
        }

    });

    $(".condition-for-automation-event").droppable({
        tolerance: "pointer",
        out: function (event, ui) {
            revert = true;
        },
        over: function (event, ui) {
            revert = false;
        },
        drop: function (event, ui) {
            revert = false;
            actualElementDepth = $(event.target).parents("*").not("body,html").size();
            var dataid = $(event.target).attr("data-id");
            if (actualElementDepth > elementDepth) {
                var top = ui.offset.top - $(this).offset().top;
                var height = 5;
                if (top >= height) {
                    $(event.target).find(".sub-children:first").append($(ui.draggable));
                }
                else {
                    $(event.target).before($(ui.draggable));
                }
                $(".condition-for-automation-event").css("left", "0px");
                $(".condition-for-automation-event").css("top", "0px");
            }
            refreshRelationships();
            elementDepth = actualElementDepth;
        }
    });
}
function deleteCondition($element) {
    $element.closest(".condition-for-automation-event").remove();
    refreshRelationships();
}

function findSubcondition(conditions, name) {
    if (name == null) {
        name = "Conditions";
    }
    else {
        name += ".Children";
    }
    var result = true;
    for (var i = 0; i < conditions.length; i++) {
        var values = $(conditions[i]).find("> .value, > span > .value");
        for (var j = 0; j < values.length; j++) {
            var $valueElement = $(values[j]);
            var value = $valueElement.val();
            var resultValue = true;//TODO:
            if ($valueElement.hasClass("spinner")) {
                resultValue = $.isNumeric(value);
            }
            if ($valueElement.hasClass("text") || $valueElement.hasClass("datepicker")) {
                resultValue = value != null && value != "";
            }
            if ($valueElement.hasClass("select2-for-users") || $valueElement.hasClass("select2-for-views")) {
                resultValue = value != null;
            }
        }
        if ($(conditions[i]).find("select.column-type").val() == -1)
        {
            resultValue = false;
        }
        if (resultValue == false) {
            result = resultValue;
            $(conditions[i]).find("> .valid-error").show(); //zobrazím chybu
        }
        else {
            $(conditions[i]).find("> .valid-error").hide(); //pokud byla zobrazena a už je to ok schovám ji
        }
        $(conditions[i]).find("> .condition-selects > .priorityId").val($(conditions[i]).find("> .condition-selects > select.column-type option:selected").data("priorityid"));
        $(conditions[i]).find("> .condition-selects > .priorityId").attr("name", name + "[" + i + "].PriorityId");
        $(conditions[i]).find("> .condition-selects > .customFormFieldId").val($(conditions[i]).find("> .condition-selects > select.column-type option:selected").data("customformfieldid"));
        $(conditions[i]).find("> .condition-selects > .customFormFieldId").attr("name", name + "[" + i + "].CustomFormFieldId");
        $(conditions[i]).find("> .condition-selects > .customerFieldId").val($(conditions[i]).find("> .condition-selects > select.column-type option:selected").data("customerfieldid"));
        $(conditions[i]).find("> .condition-selects > .customerFieldId").attr("name", name + "[" + i + "].CustomerFieldId");
        $(conditions[i]).find("> .condition-selects > .categoryId").val($(conditions[i]).find("> .condition-selects > select.column-type option:selected").data("category-id"));
        $(conditions[i]).find("> .condition-selects > .categoryId").attr("name", name + "[" + i + "].CategoryId");
        $(conditions[i]).find("> .condition-selects > select.relationship").attr("name", name + "[" + i + "].AndOrOr");
        $(conditions[i]).find("> .condition-selects > select.column-type").attr("name", name + "[" + i + "].ConditionField");

        $(conditions[i]).find("> .condition-selects > .column-operators").attr("name", name + "[" + i + "].Operator");

        if ($valueElement != undefined) {
            if ($valueElement.hasClass("spinner") || $valueElement.hasClass("text") || $valueElement.hasClass(".datepicker")) {
                $(conditions[i]).find("> .value, > span > .value").attr("name", name + "[" + i + "].Values[0]");
            }
            else {
                //tohle je pro selecty
                $(conditions[i]).find("> .value, > span > .value").attr("name", name + "[" + i + "].Values");
            }
        }

        if (result == false) {
            findSubcondition($(conditions[i]).children(".sub-children").children(".condition-for-automation-event"), name + "[" + i + "]");
            result = false;
        }
        else {
            if ($(conditions[i]).children(".sub-children").children(".condition-for-automation-event").length == 0) {
                result = true;
            }
            else {
                result = findSubcondition($(conditions[i]).children(".sub-children").children(".condition-for-automation-event"), name + "[" + i + "]");
            }
        }
    }
    return result;
}

function findSubconditionData(conditions) {
    var data = [];

    for (var i = 0; i < conditions.length; i++) {
        var dt = {
            PriorityId: $(conditions[i]).find("> .condition-selects > select.column-type option:selected").data("priorityid"),
            CustomFormFieldId: $(conditions[i]).find("> .condition-selects > select.column-type option:selected").data("customformfieldid"),
            CustomerFieldId: $(conditions[i]).find("> .condition-selects > select.column-type option:selected").data("customerfieldid"),
            CategoryId: $(conditions[i]).find("> .condition-selects > select.column-type option:selected").data("category-id"),
            AndOrOr: $(conditions[i]).find("> .condition-selects > select.relationship").val(),
            ConditionField: $(conditions[i]).find("> .condition-selects > select.column-type").val(),
            Operator: $(conditions[i]).find("> .condition-selects > .column-operators").val()
        }
        var values = $(conditions[i]).find("> .value, > span > .value");
        for (var j = 0; j < values.length; j++) {
            var $valueElement = $(values[j]);
        }

        if ($valueElement != undefined) {
            if ($valueElement.hasClass("spinner") || $valueElement.hasClass("text") || $valueElement.hasClass(".datepicker")) {
                dt.Values = new Array();
                dt.Values[0] = $(conditions[i]).find("> .value, > span > .value").val();
            }
            else {
                //tohle je pro selecty
                dt.Values = $(conditions[i]).find("> .value, > span > .value").val();
            }
        }

        if ($(conditions[i]).children(".sub-children").children(".condition-for-automation-event").length != 0) {
            dt.Children = findSubconditionData($(conditions[i]).children(".sub-children").children(".condition-for-automation-event"));
        }

        data.push(dt);
    }
    return data;
}

function conditionFieldChanged($rootElement) {
    var options = "";
    $element = $rootElement.find("> .condition-selects");
    var ruleId = $element.find("> .column-type").val();
    var priorityId = $element.find("> .column-type option:selected").data('priorityid');
    var customFormFieldId = $element.find("> .column-type option:selected").data('customformfieldid');
    var customerFieldId = $element.find("> .column-type option:selected").data('customerfieldid');
    var categoryId = $element.find("> .column-type option:selected").data('category-id');

    if (ruleId == -1) {
        $element.find("> .column-operators").hide();

        if ($element.find("> .column-operators").data('select2')) {
            $element.find("> .column-operators").select2('destroy');    
        }

        $rootElement.find("> .value, > span > .value").remove();
    }
    else {
        $.ajax({
            url: RQ_URL + getRuleOperatorValues + "?RuleId=" + ruleId + "&customerFieldId=" + customerFieldId,
            context: document.body,
            async: false
        }).done(function (data) {
            $element.find("> .column-operators > option").remove();
            $(data).each(function () {
                options += "<option value='" + this.Value + "'>" + this.Text + "</option>";
            });
            $element.find("> .column-operators").html(options);
            $element.find("> .column-operators").show();

            $element.find("> .column-operators").select2({ dropdownAutoWidth: true, minimumResultsForSearch: Infinity });
        });
        options = "";

        $.ajax({
            url: RQ_URL + getRuleEnumeratorOrDataType + "?RuleId=" + ruleId + "&priorityId=" + priorityId + "&customFormFieldId=" + customFormFieldId + "&customerFieldId=" + customerFieldId + "&categoryId=" + categoryId,
            context: document.body,
            async: false
        }).done(function (data) {
            if ($rootElement.find("> .value").data('select2')) {
                $rootElement.find("> .value").select2('destroy');
            }

            $rootElement.find("> .value, > span > .value, .text-after-value").remove();
            var operator_ddl = $element;
            setDataToRuleCondition(operator_ddl, data, null, null);
        })
        .error(function (error) {
            alert(error.responseText);
        });
    }
}

function setDataToRuleCondition(operator_ddl, data, i, index) {
    if (data.Type == "spinner") {
        operator_ddl.after('<input type="text" value="1" class="spinner value" />');
        initSpinners();
    }
    else if (data.Type == "time") {
        operator_ddl.after('<input type="text" class="left time value" placehoder="např. 2h 30m" />');
    }
    else if (data.Type == "spinnerwithsec") {
        operator_ddl.after('<input type="text" value="1" class="spinner value" /> <span  class="text-after-value">sec.</span>');
        initSpinners();
    }
    else if (data.Type == "textbox") {
        operator_ddl.after('<input type="text" class="left text value" />');
        initSpinners();
    }
    else if (data.Type == "dropdownlistuser") {
        $dropdown = $('<select class="select2-for-users value left" style="min-width:300px;" multiple="multiple"></select>');
        operator_ddl.after($dropdown);
        $dropdown.select2({
            minimumInputLength: 0,
            multiple: true,
            placeholder: Localization_Search,
            ajax: {
                url: RQ_URL + '/Account/UsersForSelect2Ajax',
                type: "POST",
                dataType: 'json',
                delay: 250,
                data: function (params) {
                    return {
                        pageSize: 10,
                        pageNum: params.page || 1,
                        term: params.term,
                        showEmail: true,
                    };
                },
                processResults: function (data, params) {
                    params.page = data.PageNum;

                    return {
                        results: data.Results,
                        pagination: {
                            more: (data.PageNum * data.PageSize) < data.Total
                        }
                    };
                },
                cache: true,
            },
            escapeMarkup: function (markup) { return markup; },
        }).addClass("left");
    }
    else if (data.Type == "dropdownlist") {
        var dropdown = $('<select class="select2-for-views value left" style="min-width:200px;" multiple="multiple" ></select>');
        operator_ddl.after(dropdown);

        var options;
        $(data.Options).each(function () {
            options += "<option value='" + this.Value + "' " + (this.Disabled ? "disabled" : "") + " >" + this.Text + "</option>";
        });
        dropdown.html(options);
        dropdown.select2({ placeholder: Localization_SelectInSelect, multiple: true }).addClass("left");
    }
    else if (data.Type == "date") {
        var date = $('<input type="text" class="left datepicker value"  />');
        operator_ddl.after(date);

        $(date).datepicker();
    }
    else if (data.Type == "dropdownlistcustomer") {
        var dropdown = $('<select class="select2-for-customers value left" style="min-width:200px;" multiple="multiple" ></select>');
        operator_ddl.after(dropdown);
        options = "";
        $(data.Options).each(function () {
            options += "<option value='" + this.Value + "'>" + this.Text + "</option>";
        });
        dropdown.html(options);
        dropdown.select2({
            minimumInputLength: 0,
            placeholder: Localization_Search,
            allowClear: true,
            ajax: {
                url: RQ_URL + '/Customers/CustomersForSelect2Ajax',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                data: function (params) {
                    return {
                        pageSize: 10,
                        pageNum: params.page || 1,
                        term: params.term,
                    };
                },
                processResults: function (data, params) {
                    params.page = data.PageNum;
                    data.Results.unshift(logged_user_select2_data_option_without_customer);

                    return {
                        results: data.Results,
                        pagination:
                        {
                            more: (data.PageNum * data.PageSize) < data.Total
                        }
                    };
                },
                cache: false,
            }
        });
    }
}

function refreshRelationships() {
    var realationships = $(".conditions").find(".condition-selects > .relationship");

    $(realationships).each(function (index, value) {
        if ($(value).data('select2')) {
            $(value).select2('destroy');
        }
        if (index == 0) {
            $(value).hide();
        }
        else {
            $(value).css("display", "inline-block");
            $(value).select2({ dropdownAutoWidth: true, minimumResultsForSearch: Infinity });
        }
    });
}


function createOptionsForColumnType(fields) {
    var currentGroupKey;
    var groupOpened = false;
    var options = "<option value='-1'>" + Localization_SelectInSelect + "</option>";

    for (var j = 0; j < fields.length; j++) {
        if (currentGroupKey != fields[j].GroupKey) {
            currentGroupKey = fields[j].GroupKey;

            if (groupOpened) {
                options += "</optgroup>";
            }

            options += '<optgroup label="' + fields[j].GroupName + '" value="' + fields[j].GroupKey + '">';
            groupOpened = true;
        }
        var htmlattributes = "";
        $(fields[j].HtmlAttributes).each(function () {
            htmlattributes += " " + this.Name + "='" + this.Value + "'";
        });

        options += "<option value='" + fields[j].Value + "'" + htmlattributes + ">" + fields[j].Text + "</option>";
    }
    if (groupOpened) {
        options += "</optgroup>";
    }
    return options;
}

function initSpinners() {
    $('.spinner').spinner({
        min: 1, max: 999, stop: function (e, ui) {
        }
    });
}

function resetConditions() {
    $('.conditions').empty();

    if ($('#ddlAreaType').val() == 'Ticket') { //Ticket = pozadavek, docasne, nez tu budou podminky i pro dalsi oblasti
        $('.btn-new-automation-condition').show();
        $('.js-conditions-block').show();
    }
    else {
        $('.js-conditions-block').hide();
    }
}