﻿$(document).ready(function () {
    InitUploader($("#IdentifierForAsyncAttachments").val());

    $("#dialog-confirm-import").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
    });
});

var uploader;

function InitUploader(identifierForAsyncAttachments) {

    uploader = new plupload.Uploader({
        runtimes: 'html5,flash,silverlight',
        url: RQ_URL + '/Inventory/Import/UploadImportAjax',
        browse_button: 'pickfiles',
        container: 'containerAttachments',
        max_file_size: '1024mb',
        chunk_size: '1024kb',
        unique_names: false,
        multiple_queues: false,
        multi_selection: false,
        multipart_params: { identifierForAsyncAttachments: identifierForAsyncAttachments },
        flash_swf_url: RQ_URL + '/Scripts/plupload/Moxie.swf',
        silverlight_xap_url: RQ_URL + '/Scripts/plupload/Moxie.xap',
        filters: [
       { title: "Excel Files", extensions: "csv" },
        ],
    });

    uploader.bind('Init', function (up, params) {
        $('#filelist').html("<ul id=\"filelistul\"></ul>");
    });

    uploader.init();

    uploader.bind('UploadProgress', function (up, file) {
        $('#up-progress').attr("style", "width: " + file.percent + "%;");
        $('#lbUploadFileSize').html(formatSize(file.loaded));
        $('#lbUploadPercentage').html(file.percent);
    });

    uploader.bind('Error', function (up, err) {
        if (err.code == -600)
            $('#filelist').append('<div class="valid-error">Error: File size is greater than 1000 MB' + (err.file ? ', File: ' + err.file.name : "") + '</div>');
        else
            $('#filelist').append("<div class='valid-error'>Error: " + err.code + ", Message: " + err.message + (err.file ? ", File: " + err.file.name : "") + "</div>");

        up.refresh(); // Reposition Flash/Silverlight
    });

    var total_upload_files = 0;

    uploader.bind('QueueChanged', function (up, files) {
        total_upload_files = uploader.files.length;

        $("#upload-status").show();
        uploader.start();

    });

    uploader.bind('FileUploaded', function (up, file) {
        total_upload_files--;
        //$("#upload-status").hide();


        //$.post(
        //RQ_URL + "/Administration/UploadImportXmlAjaxCompleted",
        //{ identifierForAsyncAttachments: $("#identifierForAsyncAttachments").val(), },
        //function (data) {
        //    if (data.success) {
        //        $("#ulAnalyzing").show();
        //        $("#lbUsers").text(data.users);
        //        $("#lbCustomers").text(data.customers);
        //        $("#lbInternalGroups").text(data.internalgroups);
        //        $("#lbOperatorGroups").text(data.operatorgroups);
        //        $("#lbServices").text(data.services);
        //        $("#lbTickets").text(data.tickets);
        //        $("#lbTicketMessages").text(data.ticketmessages);
        //        CheckImportXmlDataIntegrity();
        //    }
        //    else {
        //        ShowError(data.message);
        //    }
        //},
        //"json"
        //)
        //.error(function (error) { alert(error.responseText); });
    });

}


function formatSize(bytes) {
    if (bytes < 10 * 1024)
        return bytes + "&nbsp;B";
    else if (bytes < 10 * 1024 * 1024)
        return Math.round(bytes / 1024) + "&nbsp;kB";
    else
        return Math.round(bytes / 1024 / 1024) + "&nbsp;MB";
}