﻿var reloadImage = false;
$(document).ready(function () {

    $(".bootstrap-switches input[type='checkbox']").bootstrapSwitch();

    $('.bootstrap-switches input[type="checkbox"]').on('switchChange.bootstrapSwitch', function (event, state) {
        SaveCheckbox($(this).attr('id'), state);
    });

    /* PORTAL ITEMS */

    $('#tableOfPortalItems').on('click', '#btAddPortalItem', function () {
        AddPortalItem();
    });

    $("#dialog-confirm-portal-item-delete").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
    });

    $("#dialog-upload-icon").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        close: function (event, ui) {
            $("#dialogIcon").val("");
            if (reloadImage) {
                $("#pi" + portalItemsIdForDialog).css("background-image", "url(" + RQ_URL + "/Portal/GetIcon/" + portalItemsIdForDialog + "?v" + Math.floor((Math.random() * 100) + 1) + ")");
            }
        }
    });

    InitSortableRows();

    /* PORTAL GROUPS */

    $("#dialog-portal-groups").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [
            {
                text: Localization_Ok,
                click: function () {
                    $(this).dialog("close");
                }
            },

        ],
        close: function (event, ui) { ReloadTableOfPortalItems(); }
    });

    $('#tableOfPortalItems').on('click', '#aEditPortalGroups', function () {
        OnAjaxBegin();

        $("#dialog-portal-groups").load(
            RQ_URL + "/CustomPages/PartialPortalGroups",
            function () {
                $("#dialog-portal-groups").dialog('open');
                InitSortableGroupRows();
                OnAjaxComplete();
            }
        );
    });

    $('#dialog-portal-groups').on('click', '#btAddPortalGroup', function () {
        AddPortalGroup();
    });

    $("#dialog-confirm-portal-group-delete").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
    });

    /* JEDITABLE */
    $('#lbTitle').editable(RQ_URL + '/CustomPages/UpdateLabel',
    {
        type: 'text',
        submit: Localization_Ok,
        cancel: Localization_Cancel,
        tooltip: Localization_ClickToEdit,
        placeholder: Localization_ClickToEdit,
        width: 500,
    });

    $("#lbSubtitle").editable(RQ_URL + '/CustomPages/UpdateLabel',
    {
        type: 'textarea',
        rows: 4,
        columns: 10,
        submit: Localization_Ok,
        cancel: Localization_Cancel,
        tooltip: Localization_ClickToEdit,
        placeholder: Localization_ClickToEdit,
    });

    /* PORTAL VIEW TYPE */
    $("input[type='radio'][name='PortalViewTypeGroup']").change(function () {
        $.post(
            RQ_URL + "/CustomPages/SetPortalViewType",
            { PortalViewType: $(this).val(), },
            "json"
            )
            .error(function (error) { alert(error.responseText); });
    });

    /* NEW BUTTON BEHAVIOUR */
    $("input[type='radio'][name='NewButtonBehaviourGroup']").change(function () {
        $.post(
            RQ_URL + "/CustomPages/SetNewButtonBehaviour",
            { NewButtonBehaviour: $(this).val(), },
            "json"
            )
            .error(function (error) { alert(error.responseText); });
    });

    /* RIGHT BOX CUSTOM TEXT */

    tinymce.init({
        selector: "#divRightBoxCustomText",
        cache_suffix: "?ver=" + ver,
        theme: "modern",
        plugins: [
            "autoresize advlist autolink lists link image charmap print preview anchor",
            "searchreplace visualblocks code fullscreen",
            "insertdatetime media table contextmenu paste textcolor"
        ],
        toolbar1: "insertfile undo redo | styleselect | bold italic | forecolor backcolor | link image",
        toolbar2: "alignleft aligncenter alignright alignjustify | bullist numlist outdent indent",
        entity_encoding: "raw",
        convert_fonts_to_spans: true,
        paste_data_images: true,
        language: language,
        branding: false,
        inline: true,
        setup: function (editor) {
            editor.on('change', function (e) {
                SaveRightBoxCustomText();
            });
        }
    });


});

function SaveRightBoxCustomText() {
    $.post(
        RQ_URL + '/CustomPages/SavePortalRightBoxCustomText',
        { text: tinyMCE.get('divRightBoxCustomText').getContent() }
    )
    .error(function (error) { alert(error.responseText); });
}

function SaveCheckbox(id, value) {
    $.post(
        RQ_URL + '/CustomPages/SaveCheckbox',
        {
            id: id,
            value: value
        }
    )
    .error(function (error) { alert(error.responseText); });
}


/* PORTAL ITEMS */
var portalItemsIdForDialog = -1;

function AddPortalItem(name, description, ticketType, serviceId, portalGroupsIds) {
    $('#spanPortalItemNameRequired').hide();
    $('#spanPortalGroupRequired').hide();

    var error = false;

    if ($('#tbName').val().trim() == '') {
        $('#spanPortalItemNameRequired').show();
        error = true;
    }

    if ($('#listboxPortalGroups option:selected').length == 0) {
        $('#spanPortalGroupRequired').show();
        error = true;
    }

    if (!error) {
        $('#btAddPortalItem').addClass("loading-16");

        $.post(
            RQ_URL + "/CustomPages/AddPortalItem",
            $.param(
                {
                    name: $('#tbName').val(),
                    description: $('#tbDescription').val(),
                    ticketType: $('#ddlTicketTypes').val(),
                    serviceId: $('#ddlServices').val(),
                    portalGroupsIds: $('#listboxPortalGroups').val(),
                },
                true
            ),
            function (data) {
                if (data.success) {
                }
            },
            "json"
            )
            .error(function (error) { alert(error.responseText); })
            .success(function () { ReloadTableOfPortalItems(); })
            .done(function () { $('#btAddPortalItem').removeClass("loading-16"); });
    }
}

function ReloadTableOfPortalItems() {
    OnAjaxBegin();

    $("#tableOfPortalItems").load(
        RQ_URL + "/CustomPages/PartialTableOfPortalItems",
        function () {
            $("#tableOfPortalItems select.searchable").select2({ width: 'resolve' }); //reinit
            $("#tableOfPortalItems select.searchable100").select2({ width: '100%' }); //reinit
            InitSortableRows(); //reinit
            OnAjaxComplete();
        }
    );
}

function InitSortableRows() {
    $("#tableBodyOfPortalItems").sortable({
        handle: ".handle",
        update: function (event, ui) {
            var data = $(this).sortable('toArray', { attribute: 'data-portal-item-id' });

            $.post(
                RQ_URL + "/CustomPages/SortPortalItems",
                $.param(
                    { sortedIds: data },
                    true
                ),
                function (data) {
                },
                "json"
                )
                .error(function (error) { alert(error.responseText); })
                .success(function () { })
                .done(function () { });
        }
    });
}

function DeletePortalItemConfirm(id) {
    $("#dialog-confirm-portal-item-delete").dialog({
        buttons: [
            {
                text: Localization_Yes,
                click: function () {
                    DeletePortalItem(id);
                    $(this).dialog("close");
                }
            },
            {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });

    $("#dialog-confirm-portal-item-delete").dialog("open");
}

function DeletePortalItem(id) {
    OnAjaxBegin();

    $.post(
        RQ_URL + "/CustomPages/DeletePortalItem",
        {
            id: id,
        },
        "json"
        )
        .error(function (error) { alert(error.responseText); })
        .success(function () { ReloadTableOfPortalItems(); })
        .done(function () { OnAjaxComplete(); });
}

function EditPortalItem(id) {
    $('#tableBodyOfPortalItems tr.portal-item div.editable').hide();
    $('#tableBodyOfPortalItems tr.portal-item div.readonly').show();

    var tr = $('#tableBodyOfPortalItems tr[data-portal-item-id="' + id + '"].portal-item');

    tr.find('div.editable input[type="text"].tbName').val(tr.find('div.editable input[type="hidden"].tbName').val());
    tr.find('div.editable textarea.tbDescription').val(tr.find('div.editable input[type="hidden"].tbDescription').val());
    tr.find('div.editable select.ddlTicketTypes').val(tr.find('div.editable input[type="hidden"].ddlTicketTypes').val());
    tr.find('div.editable select.ddlServices').val(tr.find('div.editable input[type="hidden"].ddlServices').val());

    var portalGroupsIds = tr.find('div.editable input[type="hidden"].listboxPortalGroups').val().split(',');
    tr.find('div.editable select.listboxPortalGroups').val(portalGroupsIds).trigger("change");

    tr.find('div.readonly').hide();
    tr.find('div.editable').show();
}

function CancelEditPortalItem(id) {
    var tr = $('#tableBodyOfPortalItems tr[data-portal-item-id="' + id + '"].portal-item');
    tr.find('div.editable').hide();
    tr.find('div.readonly').show();
}

function SavePortalItem(id) {
    var tr = $('#tableBodyOfPortalItems tr[data-portal-item-id="' + id + '"].portal-item');

    tr.find('div.editable .spanNameRequired').hide();
    tr.find('div.editable .spanPortalGroupRequired').hide();

    var error = false;

    if (tr.find('div.editable input[type="text"].tbName').val().trim() == '') {
        tr.find('div.editable .spanNameRequired').show();
        error = true;
    }

    if (tr.find('div.editable select.listboxPortalGroups option:selected').length == 0) {
        tr.find('div.editable .spanPortalGroupRequired').show();
        error = true;
    }

    if (!error) {
        tr.find('.btSavePortalItem').addClass("loading-16");

        $.post(
            RQ_URL + "/CustomPages/SavePortalItem",
            $.param(
                {
                    id: id,
                    name: tr.find('div.editable input[type="text"].tbName').val(),
                    description: tr.find('div.editable textarea.tbDescription').val(),
                    ticketType: tr.find('div.editable select.ddlTicketTypes').val(),
                    serviceId: tr.find('div.editable select.ddlServices').val(),
                    portalGroupsIds: tr.find('div.editable select.listboxPortalGroups').val(),
                },
                true
            ),
            function (data) {
            },
            "json"
            )
            .error(function (error) { alert(error.responseText); })
            .success(function () { ReloadTableOfPortalItems(); })
            .done(function () { tr.find('.btSavePortalItem').removeClass("loading-16"); });
    }
}



/* PORTAL GROUPS */

function AddPortalGroup(name) {
    $('#spanPortalGroupNameRequired').hide();

    var error = false;

    if ($('#tbPortalGroupName').val().trim() == '') {
        $('#spanPortalGroupNameRequired').show();
        error = true;
    }

    if (!error) {
        $('#btAddPortalGroup').addClass("loading-16");

        $.post(
            RQ_URL + "/CustomPages/AddPortalGroup",
            $.param(
                {
                    name: $('#tbPortalGroupName').val(),
                },
                true
            ),
            function (data) {
                if (data.success) {
                    $('#tbPortalGroupName').val('');
                }
            },
            "json"
            )
            .error(function (error) { alert(error.responseText); })
            .success(function () { ReloadTableOfPortalGroups(); })
            .done(function () { $('#btAddPortalGroup').removeClass("loading-16"); });
    }
}

function ReloadTableOfPortalGroups() {
    $("#tableBodyOfPortalGroups").load(
        RQ_URL + "/CustomPages/PartialTableOfPortalGroups",
        function () {
            InitSortableGroupRows(); //reinit
        }
    );
}

function DeletePortalGroupConfirm(id) {
    $("#dialog-confirm-portal-group-delete").dialog({
        buttons: [
            {
                text: Localization_Yes,
                click: function () {
                    DeletePortalGroup(id);
                    $(this).dialog("close");
                }
            },
            {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });

    $("#dialog-confirm-portal-group-delete").dialog("open");
}

function DeletePortalGroup(id) {
    OnAjaxBegin();

    $.post(
        RQ_URL + "/CustomPages/DeletePortalGroup",
        {
            id: id,
        },
        "json"
        )
        .error(function (error) { alert(error.responseText); })
        .success(function () { ReloadTableOfPortalGroups(); })
        .done(function () { OnAjaxComplete(); });
}

function EditPortalGroup(id) {
    $('#tableBodyOfPortalGroups tr.portal-group div.editable').hide();
    $('#tableBodyOfPortalGroups tr.portal-group div.readonly').show();

    var tr = $('#tableBodyOfPortalGroups tr[data-portal-group-id="' + id + '"].portal-group');

    tr.find('div.editable input[type="text"].tbPortalGroupName').val(tr.find('div.editable input[type="hidden"].tbPortalGroupName').val());

    tr.find('div.readonly').hide();
    tr.find('div.editable').show();
}

function CancelEditPortalGroup(id) {
    var tr = $('#tableBodyOfPortalGroups tr[data-portal-group-id="' + id + '"].portal-group');
    tr.find('div.editable').hide();
    tr.find('div.readonly').show();
}

function SavePortalGroup(id) {
    var tr = $('#tableBodyOfPortalGroups tr[data-portal-group-id="' + id + '"].portal-group');

    tr.find('div.editable .spanPortalGroupNameRequired').hide();

    var error = false;

    if (tr.find('div.editable input[type="text"].tbPortalGroupName').val().trim() == '') {
        tr.find('div.editable .spanPortalGroupNameRequired').show();
        error = true;
    }

    if (!error) {
        tr.find('.btSavePortalGroup').addClass("loading-16");

        $.post(
            RQ_URL + "/CustomPages/SavePortalGroup",
            $.param(
                {
                    id: id,
                    name: tr.find('div.editable input[type="text"].tbPortalGroupName').val(),
                },
                true
            ),
            function (data) {
            },
            "json"
            )
            .error(function (error) { alert(error.responseText); })
            .success(function () { ReloadTableOfPortalGroups(); })
            .done(function () { tr.find('.btSavePortalGroup').removeClass("loading-16"); });
    }
}

function openDialogIcon(id) {
    showDeleteButton = $("#tpi" + id).attr("data-deletebutton");
    portalItemsIdForDialog = id;
    $("#dialogDeleteIconButton").show();
    if (showDeleteButton != "True") {
        $("#dialogDeleteIconButton").hide();
    }
    $("#dialog-upload-icon").dialog("open");
}

function InitSortableGroupRows() {
    $("#tableBodyOfPortalGroups").sortable({
        handle: ".handle",
        update: function (event, ui) {
            var data = $(this).sortable('toArray', { attribute: 'data-portal-group-id' });

            $.post(
                RQ_URL + "/CustomPages/SortPortalGroups",
                $.param(
                    { sortedIds: data },
                    true
                ),
                function (data) {
                },
                "json"
                )
                .error(function (error) { alert(error.responseText); })
                .success(function () { })
                .done(function () { });
        }
    });
}