﻿$(document).ready(function () {

    // ---- SignalR --------

    //// Create a function that the hub can call back to display messages.
    $.connection.ticketListHub.client.newTicketCreated = function (ticketId, ticketREF) {
        var viewIds = [];

        $('.desktop-view').each(function () {
            viewIds.push($(this).data('view-id'));
        })

        $.post(
            RQ_URL + "/Tickets/CheckNewTicket",
            {
                ticketId: ticketId,
                viewIds: viewIds,
                model: null,
            },
            function (data) {
                $(data.affectedViews).each(function () {
                    var $box = $('.desktop-view[data-view-id=' + this + ']');
                    var $boxNumberLink = $box.find('.number a');
                    count = parseInt($boxNumberLink.text());
                    $boxNumberLink.text(count + 1);
                    $box.addClass('changed animated pulse');
                    $boxNumberLink.addClass('animated flash');
                });

                if (data.affectedViews.length > 0) {
                    //$.playSound(RQ_URL + '/Sounds/ticket.mp3');
                }
            },
            "json"
            )
            .error(function (error) {
                if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
            });
    };

    $.connection.ticketDesktopHub.client.viewsCountCanBeChanged = function (data, notify) {
        $(data).each(function () {
            var $box = $('.desktop-view[data-view-id=' + this.viewId + ']');
            var $boxNumberLink = $box.find('.number a');
            var count = parseInt($boxNumberLink.text());

            if (count != this.count) {
                $boxNumberLink.text(this.count);

                if (notify) {
                    $box.addClass('changed animated pulse');
                    $boxNumberLink.addClass('animated flash');
                }
            }
        });

        //$.playSound(RQ_URL + '/Sounds/ticket-user-message.mp3');
    };

    //$.connection.hub.start()

    // ------------------- --------- ----------------------------------




    initPlaceHolders();

    $("#DialogNewGroupName").keypress(function () {
        $("#DialogNewGroupNameError").hide();
    });

    $("#DialogNewGroup").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Create,
            click: function () {
                $.ajax({
                    url: RQ_URL + '/Desktop/NewDesktopGroup',
                    type: "POST",
                    dataType: "html",
                    contentType: "application/json; charset=utf-8",
                    data: JSON.stringify({
                        name: $("#DialogNewGroupName").val(),
                    }),
                    success: function (html) {
                        $(".desktop-groups").append(html);
                        $("#DialogNewGroup").dialog("close");
                        initPlaceHolders();
                        initBsTooltip();
                    },

                })
                .error(function (error) {
                    if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
                });
            }
        }, {
            text: Localization_Cancel,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#DialogEditGroup").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Save,
            click: function () {
                $.ajax({
                    url: RQ_URL + '/Desktop/EditDesktopGroup',
                    type: "POST",
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    data: JSON.stringify({
                        id: $("#DialogGroupId").val(),
                        name: $("#DialogEditGroupName").val(),
                    }),
                    success: function (g) {
                        $("#panel" + $("#DialogGroupId").val()).find(".group-name").text($("#DialogEditGroupName").val());
                        $("#DialogEditGroup").dialog("close");
                        //reloadGroup(g.id);
                    },
                })
                .error(function (error) {
                    if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
                });
            }
        }, {
            text: Localization_Cancel,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#DialogAddView").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Add,
            click: function () {
                var groupId = $("#DialogAddViewGroupId").val();

                $.ajax({
                    url: RQ_URL + '/Desktop/AddViews',
                    type: "POST",
                    contentType: "application/json; charset=utf-8", //send
                    dataType: "json", //receive
                    data: JSON.stringify({
                        groupId: groupId,
                        viewsIds: $("#DialogAddViewSelect").val(),
                    }),
                    success: function (data) {
                        $(data).each(function () { //do stranky se vlozi boxy
                            $('.desktop-group[data-id="' + groupId + '"] .desktop-boxes .desktop-box-add').before(this);
                            $('.desktop-group[data-id="' + groupId + '"] .desktop-box-actions .change-color').initColorpicker(); //reinit
                        });

                        initBsTooltip();
                    },
                })
                .error(function (error) {
                    if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
                });

                $("#DialogAddView").dialog("close");
            }
        }, {
            text: Localization_Cancel,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#DialogConfirmRemoveItem").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
        width: 'auto',
        height: 'auto',
    });

    $(".desktop-groups").on("click", ".desktop-group-delete", function (event) {
        var $group = $(this).closest('.desktop-group');

        if ($group.find('.desktop-box').length > 0)
            return;

        var groupId = $group.data("id");

        $(this).tooltipBS('hide');

        $.ajax({
            url: RQ_URL + '/Desktop/DeleteDesktopGroup',
            type: "POST",
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify({
                id: groupId,
            }),
            success: function (g) {
                if (g === true) {
                    $("#panel" + groupId).remove();
                    ShowSuccess("Skupina byla smazána");
                }
                else {
                    ShowError("Skupina není prázdná");
                }
            },
        })
        .error(function (error) {
            if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
        });
    });

    


    $(".desktop-groups").on("click", ".desktop-group-move:not([disabled])", function (event) {
        var $group = $(this).closest('.desktop-group');
        var groupId = $group.data("id");
        var incrementIndex = $(this).data('increment-index') == 'True';

        $(this).tooltipBS('hide');

        $.post(
            RQ_URL + "/Desktop/MoveDesktopGroup",
            {
                id: groupId,
                incrementIndex: $(this).data('increment-index'),
            },
            function (data) {
            },
            "json"
            )
            .error(function (error) {
                if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
            });

        var $swappedGroup = null;
        
        if (incrementIndex) {
            $swappedGroup = $group.nextAll('.desktop-group').first();
            $group.before($swappedGroup);
        }
        else {
            $swappedGroup = $group.prevAll('.desktop-group').first();
            $group.after($swappedGroup);
        }
        
        var $groupUp = $group.find('.desktop-group-move[data-increment-index="False"]');
        var $groupDown = $group.find('.desktop-group-move[data-increment-index="True"]');
        var $swappedGroupUp = $swappedGroup.find('.desktop-group-move[data-increment-index="False"]');
        var $swappedGroupDown = $swappedGroup.find('.desktop-group-move[data-increment-index="True"]');
        var groupUp = $groupUp.is('[disabled]');
        var groupDown = $groupDown.is('[disabled]');

        $groupUp.prop("disabled", $swappedGroupUp.is('[disabled]'));
        $groupDown.prop("disabled", $swappedGroupDown.is('[disabled]'));

        $swappedGroupUp.prop("disabled", groupUp);
        $swappedGroupDown.prop("disabled", groupDown);

    });


    $(".desktop-groups").on("click", ".desktop-boxes .remove-desktop-item", function (event) {
        $(this).tooltipBS('hide');
        var $item = $(this).closest('.desktop-box');

        $("#DialogConfirmRemoveItem").dialog({
            buttons: [{
                text: Localization_Yes,
                click: function () {
                    

                    $.ajax({
                        url: RQ_URL + '/Desktop/RemoveDesktopItem',
                        type: "POST",
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        data: JSON.stringify({
                            id: $item.data('id'),
                        }),
                        success: function (g) {
                        },
                    })
                    .fail(function (error) {
                        if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
                    })
                    .done(function () {
                    });

                    $item.remove();

                    var $group = $item.closest('.desktop-group');

                    if ($group.find(".desktop-box").length == 0) {
                        $group.find(".desktop-group-delete").prop('disabled', false);
                    }

                    $(this).dialog("close");
                },
            }, {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }]
        });

        $("#DialogConfirmRemoveItem").dialog('open');
    });


    $(".desktop-groups").on("click", ".desktop-box-add .add-new-view", function (event) {
        var groupId = $(this).closest('.desktop-group').data('id');
        addViewToGroup(groupId);
    });

    $(".desktop-groups").on("click", ".desktop-box-add .add-new-stickynote", function (event) {
        var $group = $(this).closest('.desktop-group');

        $.ajax({
            url: RQ_URL + '/Desktop/NewDesktopStickyNote',
            type: "POST",
            contentType: "application/json; charset=utf-8", //send
            dataType: "html", //receive
            data: JSON.stringify({
                groupId: $group.data('id'),
            }),
            success: function (html) {
                $group.find('.desktop-boxes .desktop-box-add').before(html);
                $group.find('.desktop-box-actions .change-color').initColorpicker(); //reinit
                initBsTooltip();

                var $stickyNote = $group.find('.desktop-sticky-note:last');
                editStickyNote($stickyNote);
            },
        })
        .error(function (error) {
            if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
        });

    });

    $(".desktop-groups").on("click", ".desktop-view-header > span", function (event) {
        saveOpenedStickyNote();
        event.stopPropagation(); //to prevent $('html').click
        $(this).hide();
        $(this).after('<div class="input-group"><input type="text" class="form-control" placeholder="Vlastní název"><span class="input-group-btn"><button class="btn btn-secondary" type="button">OK</button></span></div>');
        $(this).parent().find('.input-group input[type="text"]').val($(this).text());
    });

    $(".desktop-groups").on("click", ".desktop-view-header .input-group", function (event) {
        event.stopPropagation(); //to prevent $('html').click
    });

    
    $('html').click(function () {
        //cancel zmeny nazvu pohledu
        $('.desktop-view-header > .input-group').remove();
        $('.desktop-view-header > span').show();

        saveOpenedStickyNote();
    });

    $(".desktop-groups").on("click", ".desktop-view-header .input-group button", function (event) {
        var name = $(this).closest('.input-group').find('input[type="text"]').val();
        var itemId = $(this).closest('.desktop-box').data('id');
        $header = $(this).closest('.desktop-view-header');
        $name = $header.children('span').text(name);

        $.post(
            RQ_URL + "/Desktop/SaveDesktopViewName",
            {
                id: itemId,
                name: name,
            },
            function (data) {
                $name.text(data); //pokud by se vracel originalni nazev (poslal se string.empty), dojde ke zmene
            },
            "json"
            )
            .error(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } });

        $header.children('.input-group').remove();
        $name.text(name);
        $name.show();
    });

  
    $(".desktop-box .desktop-box-actions .change-color").initColorpicker();

    $('.desktop-group-add').click(function () {
        newGroup();
    });

    $(".desktop-groups").on("click", ".desktop-sticky-note .sticky-note-text", function (event) {
        event.stopPropagation(); //to prevent $('html').click
        $stickyNote = $(this).closest('.desktop-sticky-note');
        editStickyNote($stickyNote);
    });

    $(".desktop-groups").on("click", ".desktop-sticky-note textarea", function (event) {
        event.stopPropagation(); //to prevent $('html').click
    });

    var $fullscreenGroup;

    $(".desktop-groups").on("click", ".desktop-group-fullscreen", function (event) {
        $(this).tooltipBS('hide');
        if (screenfull.enabled) {
            $fullscreenGroup = $(this).closest('.desktop-group');
            var target = $fullscreenGroup[0]; // Get DOM element from jQuery collection
            screenfull.toggle(target);
        }
    });

    if (screenfull.enabled) {
        document.addEventListener(screenfull.raw.fullscreenchange, function () {
            if (screenfull.isFullscreen) {
                $fullscreenGroup.find('.group-actions a:not(.desktop-group-fullscreen)').hide();
                $fullscreenGroup.find('.desktop-box-actions').css('visibility', 'hidden');
                $fullscreenGroup.find('.desktop-box-add').css('display', 'none');
            }
            else {
                $fullscreenGroup.find('.group-actions a:not(.desktop-group-fullscreen)').show();
                $fullscreenGroup.find('.desktop-box-actions').css('visibility', 'visible');
                $fullscreenGroup.find('.desktop-box-add').css('display', '');
            }
        });
    }
});

var $openedStickyNote = null;

function editStickyNote($stickyNote) {
    $note = $stickyNote.find('.sticky-note-text');
    $textarea = $stickyNote.find('textarea');
    $textarea.val($note.text());
    $note.hide();
    $textarea.show();
    $textarea.focus();
    saveOpenedStickyNote();
    $openedStickyNote = $stickyNote;

}

function saveOpenedStickyNote() {
    //ulozeni napsane poznamky
    if ($openedStickyNote != null) {
        $note = $openedStickyNote.find('.sticky-note-text');
        $textarea = $openedStickyNote.find('textarea');

        var text = $textarea.val();
        $note.text(text);

        $textarea.hide();
        $note.show();

        var id = $openedStickyNote.data('id');

        $.post(
            RQ_URL + "/Desktop/SaveDesktopStickyNoteText",
            {
                id: id,
                text: text,
            },
            function (data) {
            },
            "json"
            )
            .error(function (error) { if (typeof error.responseText !== 'undefined') { alert(error.responseText); } });

        $openedStickyNote = null;
    }
}

//function reloadGroup(groupId) {
//    $("#panel" + groupId).load(RQ_URL + "/Desktop/ReloadGroup/" + groupId, function () {
//        initPlaceHolders();
//        initBsTooltip();
//    });
//}

function addViewToGroup(groupId) {
    $("#DialogAddViewGroupId").val(groupId);
    $("#DialogAddView").dialog("open");
    $("#DialogAddViewViews").html("<div class='loading-32'></div>");
    $("#DialogAddViewViews").load(RQ_URL + "/Desktop/ViewForGroup");
}

function newGroup() {
    $("#DialogNewGroupName").val("");
    $("#DialogNewGroupNameError").hide();
    $("#DialogNewGroup").dialog("open");
}

function editGroup(groupId) {
    $("#DialogGroupId").val(groupId);
    $("#DialogEditGroupName").val($.trim($("#panel" + groupId).find(".group-name").text()));
    $("#DialogEditGroupNameError").hide();
    $("#DialogEditGroup").dialog("open");
}

function initPlaceHolders() {
    position_updated = false; //flag bit

    $(".desktop-boxes").sortable({
        connectWith: ".desktop-boxes",
        handle: ".desktop-box-handle",
        //cancel: ".desktop-box-add",
        items: ".desktop-box",
        placeholder: "desktop-box-placeholder",
        update: function (event, ui) {
            position_updated = !ui.sender; //if no sender, set sortWithin flag to true
        },
        remove: function (event, ui) { //This event is triggered when a sortable item from the list has been dropped into another. The former is the event target.
            if ($(this).closest(".desktop-group").data("id") == undefined) {
                if ($(this).closest(".panel").find(".desktop-box").length == 0) {
                    $(this).closest(".panel").remove();
                }
            }
            else {
                if ($("#panel" + $(this).closest(".desktop-group").data("id")).find(".desktop-box").length == 0) {
                    $("#panel" + $(this).closest(".desktop-group").data("id")).find(".desktop-group-delete").show();
                }
            }
        },
        stop: function (event, ui) { //This event is triggered when sorting has stopped.
            //alert('stop');
            if (position_updated) {
                $(ui.item).closest(".desktop-boxes").append($(ui.item).closest(".desktop-boxes").find(".desktop-box-add").detach());
                // The position where the new item was dropped
                var newIndex = ui.item.index();
                var groupId = $(this).closest(".desktop-group").data("id");
                $.ajax({
                    url: RQ_URL + '/Desktop/SetDesktopItemPositionAndGroup',
                    type: "POST",
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    data: JSON.stringify({
                        groupId: groupId,
                        itemId: $(ui.item).data("id"),
                        position: newIndex
                    }),
                })
                .error(function (error) {
                    if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
                });
            }
        },
        receive: function (event, ui) { //This event is triggered when an item from a connected sortable list has been dropped into another list. The latter is the event target.
            //alert('reveive');
            // The position where the new item was dropped
            if ($("#panel" + $(this).data("id")).find(".desktop-box").length > 0) {
                $("#panel" + $(this).data("id")).find(".desktop-group-delete").hide();
            }
            $(ui.item).closest(".desktop-boxes").append($(ui.item).closest(".desktop-boxes").find(".desktop-box-add").detach());
            var newIndex = ui.item.index();
            var groupId = $(this).closest(".desktop-group").data("id");
            $.ajax({
                url: RQ_URL + '/Desktop/SetDesktopItemPositionAndGroup',
                type: "POST",
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                data: JSON.stringify({
                    groupId: groupId,
                    itemId: $(ui.item).data("id"),
                    position: newIndex
                }),
            })
            .error(function (error) {
                if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
            });
        },
    });
}




var closingColorPicker = false;

$.fn.initColorpicker = function () {
    $(this).colorpicker({
        //container: $(this).closest('.desktop-box'),
        //color: '#45a099',
        colorSelectors: {
            'stickynote': '#ffffcc',
            'orange': '#f0ad4e',
            'green': '#5cb85c',
            'lightblue': '#5bc0de',
            'darkblue': '#337ab7',
            'lightred': '#d9534f',
            'darkred': '#b90600',
            'pink': '#ec2b8c',
            'purple': '#763f98',
            'default': '#7f7f7f',
            'chocolate': '#7B3F00',
        }
    })
    .on('changeColor', function (event) {
        //alert(event.color.toHex());
        var color = event.color;
        color.a = '0.9';
        $(this).closest(".desktop-box.desktop-view").find(".desktop-view-content").css('background-color', color.toHex());
        $(this).closest(".desktop-box.desktop-sticky-note").css('background-color', color.toHex());
    })
    .on('hidePicker', function (event) {
        //alert(event.color.toHex());
        if (!closingColorPicker) { //hack to prevent calling this twice, maybe colorpicker bug

            closingColorPicker = true;
            var $desktopBox = $(this).closest('.desktop-box');
            var itemId = $desktopBox.data('id');

            $.ajax({
                url: RQ_URL + '/Desktop/SaveDesktopItemColor',
                type: "POST",
                contentType: "application/json; charset=utf-8", //send
                dataType: "html", //receive
                data: JSON.stringify({
                    id: itemId,
                    color: event.color.toHex(),
                }),
                success: function (html) {
                    $desktopBox.replaceWith(html);
                    $('.desktop-box[data-id="' + itemId + '"] .desktop-box-actions .change-color').initColorpicker(); //reinit the replaced box only
                    closingColorPicker = false;
                    initBsTooltip();
                },
            })
            .error(function (error) {
                if (typeof error.responseText !== 'undefined') { alert(error.responseText); }
            });
        }
    });
}